MachineDeployment [cluster.x-k8s.io/v1beta1]
- Description
- MachineDeployment is the Schema for the machinedeployments API.
- Type
object
Specification
.spec
- Description
- spec is the desired state of MachineDeployment.
- Type
object- Required
clusterNameselectortemplate
.spec.machineNamingStrategy
- Description
- machineNamingStrategy allows changing the naming pattern used when creating Machines. Note: InfraMachines & BootstrapConfigs will use the same name as the corresponding Machines.
- Type
object
.spec.selector
- Description
- selector is the label selector for machines. Existing MachineSets whose machines are selected by this will be the ones affected by this deployment. It must match the machine template's labels.
- Type
object
.spec.selector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.selector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.selector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.selector.matchExpressions[].values[]
- Type
string
.spec.selector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.strategy
- Description
- strategy is the deployment strategy to use to replace existing machines with new ones.
- Type
object
.spec.strategy.remediation
- Description
- remediation controls the strategy of remediating unhealthy machines and how remediating operations should occur during the lifecycle of the dependant MachineSets.
- Type
object
.spec.strategy.rollingUpdate
- Description
- rollingUpdate is the rolling update config params. Present only if MachineDeploymentStrategyType = RollingUpdate.
- Type
object
.spec.template
- Description
- template describes the machines that will be created.
- Type
object
.spec.template.spec
- Description
- spec is the specification of the desired behavior of the machine. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
- Type
object- Required
bootstrapclusterNameinfrastructureRef
.spec.template.spec.bootstrap
- Description
- bootstrap is a reference to a local struct which encapsulates fields to configure the Machine’s bootstrapping mechanism.
- Type
object
.spec.template.spec.bootstrap.configRef
- Description
- configRef is a reference to a bootstrap provider-specific resource that holds configuration details. The reference is optional to allow users/operators to specify Bootstrap.DataSecretName without the need of a controller.
- Type
object
.spec.template.spec.infrastructureRef
- Description
- infrastructureRef is a required reference to a custom resource offered by an infrastructure provider.
- Type
object
.spec.template.spec.readinessGates
- Description
- readinessGates specifies additional conditions to include when evaluating Machine Ready condition. This field can be used e.g. by Cluster API control plane providers to extend the semantic of the Ready condition for the Machine they control, like the kubeadm control provider adding ReadinessGates for the APIServerPodHealthy, SchedulerPodHealthy conditions, etc. Another example are external controllers, e.g. responsible to install special software/hardware on the Machines; they can include the status of those components with a new condition and add this condition to ReadinessGates. NOTE: This field is considered only for computing v1beta2 conditions. NOTE: In case readinessGates conditions start with the APIServer, ControllerManager, Scheduler prefix, and all those readiness gates condition are reporting the same message, when computing the Machine's Ready condition those readinessGates will be replaced by a single entry reporting "Control plane components: " + message. This helps to improve readability of conditions bubbling up to the Machine's owner resource / to the Cluster).
- Type
array
.spec.template.spec.readinessGates[]
- Description
- MachineReadinessGate contains the type of a Machine condition to be used as a readiness gate.
- Type
object- Required
conditionType
.spec.template.spec.taints
- Description
- The list of the taints to be applied to the corresponding Node in additive manner. This list will not overwrite any other taints added to the Node on an ongoing basis by other entities. These taints should be actively reconciled e.g. if you ask the machine controller to apply a taint and then manually remove the taint the machine controller will put it back) but not have the machine controller remove any taints
- Type
array
.spec.template.spec.taints[]
- Description
- The node this Taint is attached to has the "effect" on any pod that does not tolerate the Taint.
- Type
object- Required
effectkey
.status
- Description
- status is the observed state of MachineDeployment.
- Type
object
.status.conditions
- Description
- conditions defines current service state of the MachineDeployment.
- Type
array
.status.conditions[]
- Description
- Condition defines an observation of a Cluster API resource operational state.
- Type
object- Required
lastTransitionTimestatustype
.status.v1beta2
- Description
- v1beta2 groups all the fields that will be added or modified in MachineDeployment's status with the V1Beta2 version.
- Type
object
.status.v1beta2.conditions
- Description
- conditions represents the observations of a MachineDeployment's current state. Known condition types are Available, MachinesReady, MachinesUpToDate, ScalingUp, ScalingDown, Remediating, Deleting, Paused.
- Type
array
.status.v1beta2.conditions[]
- Description
- Condition contains details for one aspect of the current state of this API Resource.
- Type
object- Required
lastTransitionTimemessagereasonstatustype
API Endpoints
The following API endpoints are available:
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeploymentsDELETE: delete collection of MachineDeploymentGET: list objects of kind MachineDeploymentPOST: create a new MachineDeployment
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeployments/{name}DELETE: delete the specified MachineDeploymentGET: read the specified MachineDeploymentPATCH: partially update the specified MachineDeploymentPUT: replace the specified MachineDeployment
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeployments/{name}/statusGET: read status of the specified MachineDeploymentPATCH: partially update status of the specified MachineDeploymentPUT: replace status of the specified MachineDeployment
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeployments
- HTTP method
DELETE- Description
- delete collection of MachineDeployment
- HTTP responses
- HTTP method
GET- Description
- list objects of kind MachineDeployment
- HTTP responses
- HTTP method
POST- Description
- create a new MachineDeployment
- Query parameters
- Body parameters
- HTTP responses
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeployments/{name}
- HTTP method
DELETE- Description
- delete the specified MachineDeployment
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified MachineDeployment
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified MachineDeployment
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified MachineDeployment
- Query parameters
- Body parameters
- HTTP responses
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/machinedeployments/{name}/status
- HTTP method
GET- Description
- read status of the specified MachineDeployment
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified MachineDeployment
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified MachineDeployment
- Query parameters
- Body parameters
- HTTP responses